<?
/************************************************************************
 * Web Tools (WT) - a collection of web hosting tools                   *
 * Module BACKUP - 0.2 - backup and zip files/directories                                                                    *
 * Copyright (C) 2000-2004 Colin Verot - colin@verot.net                *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful, but  *
 * WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    *
 * General Public License for more details.                             *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 *    Free Software Foundation, Inc.                                    *
 *    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.         *
 ************************************************************************/
 
 // defines the config file path and name
$wt_cfg_config_file = $wt_config_dir . $wt_section . ".cfg";

$wt_cfg_tar_date_ext = date("_Y-m-d_G-i") . ".tar.gz";
?>

<center>
<h2><? echo $wt_title; ?></h2>

<?
if (wt_read_cfg_file()) {
    
    // we fill the required data with dummy one if there is no data (three first lines of cfg file)
    if (count($wt_cfg_item) < 2) { 
        $wt_cfg_item[0] = "my_file_name_no_ext";
        $wt_cfg_item[1] = "/home/your_document_root/dir/";
        $wt_cfg_item[2] = "http://www.mydomain.com/dir/)";
        wt_update_cfg_file();
    }

    wt_attribute_cfg();
    
    if ($wt_action=="cfgadd") { // --------------------------------- add cfg item --------
        $wt_filepath    = trim(wt_init_var('filepath'));
        if (empty($wt_filepath)) {
            wt_error("path is empty");
        } else if (wt_is_valid_path($wt_filepath)) {
            wt_error("path contains bad characters");
        } else {
            wt_msg("path '$wt_filepath' added successfuly in the configuration file");
            $wt_cfg_item[count($wt_cfg_item)] = $wt_filepath;
            wt_update_cfg_file();
            wt_attribute_cfg();
        }
        // we added the file; we get the list again
        $wt_action="";
    }

    if ($wt_action=="cfgupdate") { // --------------------------------- update main cfg --------
        $wt_tarname   = trim(wt_init_var('tarname'));
        $wt_tardir    = trim(wt_init_var('tardir'));
        $wt_tarurl    = trim(wt_init_var('tarurl'));
        if (empty($wt_tarname)) {
            wt_error("tar name is empty");
        } else if (wt_is_valid_name($wt_tarname)) {
            wt_error("tar name contains bad characters");
        } else if (empty($wt_tardir)) {
            wt_error("tar directory is empty");
        } else if (wt_is_valid_path($wt_tardir)) {
            wt_error("tar directory contains bad characters");
        } else if (empty($wt_tarurl)) {
            wt_error("tar URL is empty");
        } else {
            wt_msg("configuration file updated successfuly");
            $wt_cfg_item[0] = $wt_tarname;
            $wt_cfg_item[1] = $wt_tardir;
            $wt_cfg_item[2] = $wt_tarurl;
            wt_update_cfg_file();
            wt_attribute_cfg();
        }
        // we updated the file; we get the list again
        $wt_action="";
    }

    if ($wt_action=="cfgdel") { // --------------------------------- del cfg item --------
        $wt_item_id     = wt_init_var('id');
        wt_msg("path '" . $wt_cfg_item[$wt_item_id] . "' deleted successfuly from the configuration file");
        $wt_cfg_item[$wt_item_id] = '';
        wt_update_cfg_file();
        wt_attribute_cfg();
        // we deleted the file; we get the list again
        $wt_action="";
    }
  
	if ($wt_action=="zip") { // --------------------------------- zip --------
		wt_msg("processing ...");
		flush();
		$wt_exec = "tar cvf " . $wt_tar_dir . $wt_tar_file_name . $wt_cfg_tar_date_ext . " ";
        for ($wt_cpt = $wt_cfg_item_shift; $wt_cpt < count($wt_cfg_item); $wt_cpt++) {
 			$wt_exec .= "" . $wt_cfg_item[$wt_cpt] . " ";         
		}
		exec($wt_exec);
		wt_msg("done.");        
		wt_msg("<a href=\"" . $wt_tar_dir_url . $wt_tar_file_name . $wt_cfg_tar_date_ext . "\">" . $wt_tar_dir.$wt_tar_file_name . $wt_cfg_tar_date_ext . "</a>");
    }

	if (!isset($wt_action) || $wt_action == "") {  // --------------------------------- MAIN --------
?>  
  <script language="JavaScript">
        function wt_cfg_del(id) {
            cf = confirm("Are you sure you want to remove this path from the list (it actually doesn't delete any file on disk)?");
            if (cf) {
                document.location = "<? echo $PHP_SELF; ?>?section=<? echo $wt_section; ?>&action=cfgdel&id="+id+"";
            }
        }
  </script>
  <table class="list">
    <tr>
      <td class="top">path file/directory</td>
      <td class="top">status</td>
      <td class="top">action</td>
    </tr>
<?	    $wt_col = 1; $wt_cpt = 0;
        for ($wt_cpt = $wt_cfg_item_shift; $wt_cpt < count($wt_cfg_item); $wt_cpt++) {
            if (!empty($wt_cfg_item[$wt_cpt])) {
         		echo "<tr><td class=\"line" . $wt_col . "\">" . $wt_cfg_item[$wt_cpt] . "</td>";
         		$wt_init = wt_init_tar_file($wt_cfg_item[$wt_cpt]);
         		if ($wt_init == "OK") {
         		    echo "<td class=\"line" . $wt_col . "\" align=\"center\"><span class=\"ok\">OK</span></td>";
                } else {
         		    echo "<td class=\"line" . $wt_col . "\" align=\"center\"><span class=\"bad\">$wt_init!</span></td>";
                }
                echo "<td class=\"line" . $wt_col . "\" align=\"center\"><a  class=\"submit\" href=\"javascript:wt_cfg_del('$wt_cpt')\">remove</a></td>";
                echo "</tr>";
                $wt_col++; if ($wt_col==3) $wt_col=1;  
            }       
    	}
        echo "<form name=\"form_add\" action=\"" . $PHP_SELF . "\"><tr>";
        echo "<tr><td class=\"line" . $wt_col . "\" colspan=\"2\"><input type=\"text\" size =\"40\" name=\"filepath\" class=\"table\"></td>";
        echo "<td class=\"line" . $wt_col . "\"><input type=\"hidden\" name=\"section\" value=\"$wt_section\">";
        echo "<input type=\"hidden\" name=\"action\" value=\"cfgadd\">";
        echo "<input type=\"submit\" name=\"submit\" value=\"add\" class=\"submit\"></td></tr>";
        echo "</form>";
?>
  </table>
  <br /><h3>in</h3>
  <table class="list">
    <form name="form_cfg" action="<? echo $PHP_SELF; ?>">
    <tr>
      <td class="line" align="right">tar name :</td>
      <td class="line" colspan="2"><input type="text" size="50" name="tarname" value="<? echo $wt_tar_file_name; ?>"></td>
    </tr>
    <tr>
      <td class="line" align="right">tar directory :</td>
      <td class="line" colspan="2"><input type="text" size="50" name="tardir" value="<? echo $wt_tar_dir; ?>"></td>
    </tr>
    <tr>
      <td class="line" align="right">tar url :</td>
      <td class="line"><input type="text" size="35" name="tarurl" value="<? echo $wt_tar_dir_url; ?>"></td>
      <td class="line"><input type="hidden" name="action" value="cfgupdate"><input type="hidden" name="section" value="<? echo $wt_section; ?>"><input type="submit" name="submit" value="update" class="submit"></td>
    </tr>
    </form>
  </table>
  
  <br />
  <a href="<? echo $PHP_SELF; ?>?section=<? echo $wt_section; ?>&action=zip"><b>zip  <?    echo $wt_tar_dir . $wt_tar_file_name . $wt_cfg_tar_date_ext; ?></b></a>
  <br /><br />
<? 	
    } 
?>
</center>

<?
}

function wt_attribute_cfg() {
    global $wt_cfg_item, $wt_cfg_item_shift;
    global $wt_tar_file_name, $wt_tar_dir, $wt_tar_dir_url;
    $wt_tar_file_name = $wt_cfg_item[0];
    $wt_tar_dir = $wt_cfg_item[1];
    $wt_tar_dir_url = $wt_cfg_item[2];
    $wt_cfg_item_shift = 3;   
}

function wt_init_tar_file($wt_file) {
    if (!file_exists($wt_file)) return "missing";
    if (!is_readable($wt_file)) return "not readable";
    // if (!is_writeable($wt_file)) return "not writeable";
    return "OK";
}
?>



