<?
/************************************************************************
 * Web Tools (WT) - a collection of web hosting tools                   *
 * Module SQLDUMP - 0.1 - dumps a mySQL database                        *
 * Copyright (C) 2000-2004 Colin Verot - colin@verot.net                *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful, but  *
 * WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    *
 * General Public License for more details.                             *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 *    Free Software Foundation, Inc.                                    *
 *    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.         *
 ************************************************************************/
 
 // defines the config file path and name
$wt_cfg_config_file = $wt_config_dir . $wt_section . ".cfg";

$wt_cfg_sql_date_ext = date("_Y-m-d_G-i") . ".sql";
?>

<center>
<h2><? echo $wt_title; ?></h2>


<?// reads the config file, and carries on only if file is accessible
if (wt_read_cfg_file()) {
    
    wt_attribute_cfg();

    if (count($wt_cfg_item) < 2) { // we fill the required data with dummy one if there is no data (three first lines of cfg file)
        $wt_cfg_item[0] = "sql server";
        $wt_cfg_item[1] = "user";
        $wt_cfg_item[2] = "password";
        $wt_cfg_item[3] = "base";
        $wt_cfg_item[4] = "my_file_name_no_ext";
        $wt_cfg_item[5] = "/home/your_document_root/dir/";
        $wt_cfg_item[6] = "http://www.mydomain.com/dir/";
        wt_update_cfg_file();
    }

    if ($wt_action=="cfgupdate") { // --------------------------------- update main cfg --------
        $wt_sqlserver   = trim(wt_init_var('sqlserver'));
        $wt_sqluser     = trim(wt_init_var('sqluser'));
        $wt_sqlpassword = trim(wt_init_var('sqlpassword'));
        $wt_sqlbase     = trim(wt_init_var('sqlbase'));
        $wt_sqlname     = trim(wt_init_var('sqlfilename'));
        $wt_sqldir      = trim(wt_init_var('sqldir'));
        $wt_sqlurl      = trim(wt_init_var('sqlurl'));
        if (empty($wt_sqlserver)) {
            wt_error("sql server is empty");
        } else if (empty($wt_sqluser)) {
            wt_error("sql user is empty");
        } else if (empty($wt_sqlbase)) {
            wt_error("sql base is empty");
        } else if (empty($wt_sqlname)) {
            wt_error("sql dump filename is empty");
        } else if (wt_is_valid_name($wt_sqlname)) {
            wt_error("sql dump filename contains bad characters");
        } else if (empty($wt_sqldir)) {
            wt_error("sql dump directory is empty");
        } else if (wt_is_valid_path($wt_sqldir)) {
            wt_error("sql dump directory contains bad characters");
        } else if (empty($wt_sqlurl)) {
            wt_error("sql dump url is empty");
        } else {
            wt_msg("configuration file updated successfuly");
            $wt_cfg_item[0] = $wt_sqlserver;
            $wt_cfg_item[1] = $wt_sqluser;
            $wt_cfg_item[2] = $wt_sqlpassword;
            $wt_cfg_item[3] = $wt_sqlbase;
            $wt_cfg_item[4] = $wt_sqlname;
            $wt_cfg_item[5] = $wt_sqldir;
            $wt_cfg_item[6] = $wt_sqlurl;
            wt_update_cfg_file();
            wt_attribute_cfg();
        }
        // we updated the file; we get the list again
        $wt_action="";
    }
  
	if ($wt_action=="dump") { // --------------------------------- dump --------
		wt_msg("processing ...");
		flush();
		$wt_exec = "mysqldump -h" . $wt_sql_server . " -u" . $wt_sql_user . " -p" . $wt_sql_password . " " . $wt_sql_base . "> " . $wt_sql_dir . $wt_sql_file_name . $wt_cfg_sql_date_ext . " ";
		exec($wt_exec);
		wt_msg("done.");        
		wt_msg("<a href=\"" . $wt_sql_dir_url . $wt_sql_file_name . $wt_cfg_sql_date_ext . "\">" . $wt_sql_dir . $wt_sql_file_name . $wt_cfg_sql_date_ext . "</a>");
    }

	if (!isset($wt_action) || $wt_action == "") {  // --------------------------------- MAIN --------
?>  

  <table class="list">
    <form name="form_cfg" action="<? echo $PHP_SELF; ?>">
    <tr>
      <td class="line" align="right">sql server :</td>
      <td class="line" colspan="2"><input type="text" size="50" name="sqlserver" value="<? echo $wt_sql_server; ?>"></td>
    </tr>
    <tr>
      <td class="line" align="right">sql user :</td>
      <td class="line" colspan="2"><input type="text" size="50" name="sqluser" value="<? echo $wt_sql_user; ?>"></td>
    </tr>
    <tr>
      <td class="line" align="right">sql password :</td>
      <td class="line" colspan="2"><input type="password" size="50" name="sqlpassword" value="<? echo $wt_sql_password; ?>"></td>
    </tr>
    <tr>
      <td class="line" align="right">sql base :</td>
      <td class="line" colspan="2"><input type="text" size="50" name="sqlbase" value="<? echo $wt_sql_base; ?>"></td>
    </tr>
    <tr>
      <td class="line" align="right">sql dump file name :</td>
      <td class="line" colspan="2"><input type="text" size="50" name="sqlfilename" value="<? echo $wt_sql_file_name; ?>"></td>
    </tr>
    <tr>
      <td class="line" align="right">sql dump directory :</td>
      <td class="line" colspan="2"><input type="text" size="50" name="sqldir" value="<? echo $wt_sql_dir; ?>"></td>
    </tr>
    <tr>
      <td class="line" align="right">sql dump url :</td>
      <td class="line"><input type="text" size="35" name="sqlurl" value="<? echo $wt_sql_dir_url; ?>"></td>
      <td class="line"><input type="hidden" name="action" value="cfgupdate"><input type="hidden" name="section" value="<? echo $wt_section; ?>"><input type="submit" name="submit" value="update" class="submit"></td>
    </tr>
    </form>
  </table>
  
  <br />
  <a href="<? echo $PHP_SELF; ?>?section=<? echo $wt_section; ?>&action=dump"><b>dump '<? echo $wt_sql_base; ?>' in <?    echo $wt_sql_dir . $wt_sql_file_name . $wt_cfg_sql_date_ext; ?></b></a>
  <br /><br />
<? 	
    } 
?>
</center>

<?
}

function wt_attribute_cfg() {
    global $wt_cfg_item, $wt_cfg_item_shift;
    global $wt_sql_server, $wt_sql_user, $wt_sql_password, $wt_sql_base, $wt_sql_file_name, $wt_sql_dir, $wt_sql_dir_url;
    $wt_sql_server      = $wt_cfg_item[0];
    $wt_sql_user        = $wt_cfg_item[1];
    $wt_sql_password    = $wt_cfg_item[2];
    $wt_sql_base        = $wt_cfg_item[3];
    $wt_sql_file_name   = $wt_cfg_item[4];
    $wt_sql_dir         = $wt_cfg_item[5];
    $wt_sql_dir_url     = $wt_cfg_item[6];
    $wt_cfg_item_shift  = 7;   
}

?>



